# Run tests in check section
# disable for bootstrapping
%bcond_with check
%global with_debug 1
%if 0%{?with_debug}
%global debug_package   %{nil}
%endif
Name:           deepin-pw-check
Version:        5.1.17
Release:        2%{?dist}
Summary:        Used to check password and manager the configuration for password.
License:        GPLv3
URL:            https://github.com/linuxdeepin/deepin-pw-check
Source0:        %{url}/archive/%{version}/%{name}-%{version}.tar.gz

Patch1000:      0001-fix-for-UonioTech.patch
#uelc patch
##Patch1001:      0001-Mangle-Suit-Cracklib2.9.6.patch
#uel patch
Patch1002:      1000-deepin-pw-check-modify-password-policy.patch

BuildRequires:  compiler(go-compiler)
BuildRequires:  pam-devel
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(gdk-3.0)
BuildRequires:  deepin-gettext-tools
BuildRequires:  gocode

BuildRequires:  cracklib-devel
BuildRequires:  iniparser-devel
BuildRequires:  go-dbus-factory-devel
BuildRequires:  go-lib-devel
BuildRequires:  go-gir-generator

Requires:       polkit
%description
In order to unify the authentication interface,
this interface is designed to adapt to fingerprint, face and other authentication methods.

%package devel
Summary: Header files and libraries used to build deepin-pw-check
Requires: %{name} = %{version}-%{release}
Requires: cracklib-devel iniparser-devel

%description devel
In order to unify the authentication interface,
this interface is designed to adapt to fingerprint, face and other authentication methods.

%prep
%setup -q
%patch1000  -p1
%if 0%{?openeuler}
%patch1002  -p1
%else
##%patch1001  -p1
%endif

%build
%ifarch loongarch64
export CGO_ENABLED=1
export GOOS="linux"
%endif


export GO111MODULE=auto

BUILDID="0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \n')"
export GOPATH=/usr/share/gocode/:$GOPATH
%make_build GO_BUILD_FLAGS=-trimpath GOBUILD="go build -compiler gc -ldflags \"-B $BUILDID\""

%post
pwd-conf-update
sed -i "s/pam_pwquality.so/pam_deepin_pw_check.so/g" /etc/pam.d/system-auth
sed -i "s/pam_pwquality.so/pam_deepin_pw_check.so/g" /etc/pam.d/password-auth

%postun
if [ "$1" = "0" ] ; then
        sed -i "s/pam_deepin_pw_check.so/pam_pwquality.so/g" /etc/pam.d/system-auth
        sed -i "s/pam_deepin_pw_check.so/pam_pwquality.so/g" /etc/pam.d/password-auth
fi

%install
mkdir -p %{buildroot}/%{_sysconfdir}/deepin
export GOPATH=%{_datadir}/gocode
export PKG_FILE_DIR=%{_libdir}/pkgconfig
%make_install PKG_FILE_DIR=%{_libdir}/pkgconfig LIBDIR=lib64 PAM_MODULE_DIR=%{_libdir}/security GOBUILD="go build -compiler gc -ldflags \"-B $BUILDID\""
%find_lang deepin-pw-check

%ifarch i686
mv %{buildroot}/usr/lib64/libdeepin_pw_check.so* %{buildroot}/usr/lib/
%endif

%files -f deepin-pw-check.lang
%doc README.md
%license
%dir %{_sysconfdir}/deepin
%{_bindir}/pwd-conf-update
%{_prefix}/lib/deepin-pw-check/deepin-pw-check
%{_libdir}/libdeepin_pw_check.so.*
%ifarch i686
/usr/lib/security/pam_deepin_pw_check.so
%else
%{_libdir}/security/pam_deepin_pw_check.so
%endif
%{_datadir}/dbus-1/system-services/*.service
%{_datadir}/dbus-1/system.d/*.conf
%{_datadir}/polkit-1/actions/*.policy

%files devel
%ifarch i686
/usr/lib64/libdeepin_pw_check.a
/usr/lib/pkgconfig/libdeepin_pw_check.pc
%else
%{_libdir}/libdeepin_pw_check.a
%{_libdir}/pkgconfig/libdeepin_pw_check.pc
%endif
%{_libdir}/libdeepin_pw_check.so
%{_includedir}/deepin_pw_check.h

%changelog
* Mon Feb 27 2023 liweiganga <liweiganga@uniontech.com> - 5.1.17-2
- feat: modify patch1002(bugid:187961)

* Sat Feb 25 2023 lvgenggeng <lvgenggeng@uniontech.com> - 5.1.17-1.02
- rebuild

* Fri Jan 06 2023 liweiganga <liweiganga@uniontech.com> - 5.1.17-1.01
- feat: use gocode and fix build error 

* Wed Dec 28 2022 liweiganga <liweiganga@uniontech.com> - 5.1.17-1
- update: update to 5.1.17

* Thu Jun 30 2022 liweiganga <liweiganga@uniontech.com> - 5.1.4-1.06
- spec: modify CG0_ENABLED to CGO_ENABLED

* Thu Jun 30 2022 liweiganga <liweiganga@uniontech.com> - 5.1.4-1.05
- fix: remove 'go env -w GO111MODULE=auto'

* Thu Jun 30 2022 liweiganga <liweiganga@uniontech.com> - 5.1.4-1.04
- fix: fix the failure of password verification when the administrator creates a user for the first time(bugid:145111)

* Mon Jun 27 2022 songmingliang <songmingliang@uniontech.com> - 5.1.4-1.03
- fix: delete blank(bugid:140999)(sync from 105xe)

* Mon Jun 13 2022 liweigang <liweiganga@uniontech.com> - 5.1.4-1.02
- fix: add patches

* Mon Jun 13 2022 uoser <uoser@uniontech.com> - 5.1.4-1
- Update to 5.1.4
